unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtDlgs, FileCtrl, ExtCtrls;

type
  TForm1 = class(TForm)
    ButtonClearDisplay: TButton;
    ButtonEnde: TButton;
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    ButtonBild: TButton;
    Image1: TImage;
    ButtonBW: TButton;
    Image2: TImage;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    ButtonToLcd: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonClearDisplayClick(Sender: TObject);
    procedure ButtonEndeClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure ButtonBildClick(Sender: TObject);
    procedure ButtonBWClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ButtonToLcdClick(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  LPT_adr = $0378;
  p_PWR = $0E0;
  p_CLK = $01;
  p_DIN = $02;
  p_DC = $04;
  p_CE = $08;
  p_RES = $10;
  xres = 84;
  yres = 6;

const
 Zeichen: array[0..479] of Byte =
 ($00,$00,$00,$00,$00,	// 20 space	ASCII table for NOKIA LCD: 96 rows * 5 bytes= 480 bytes
  $00,$00,$5f,$00,$00,	// 21 !		Note that this is the same set of codes for character you
  $00,$07,$00,$07,$00,	// 22 "		would find on a HD44780 based character LCD. :)
  $14,$7f,$14,$7f,$14,	// 23 #		Also, given the size of the LCD (84 pixels by 48 pixels),
  $24,$2a,$7f,$2a,$12,	// 24 $		the maximum number of characters per row is only 14. :)
  $23,$13,$08,$64,$62,	// 25 %
  $36,$49,$55,$22,$50,	// 26 &
  $00,$05,$03,$00,$00,	// 27 '
  $00,$1c,$22,$41,$00,	// 28 (
  $00,$41,$22,$1c,$00,	// 29 )
  $14,$08,$3e,$08,$14,	// 2a *
  $08,$08,$3e,$08,$08,	// 2b +
  $00,$50,$30,$00,$00,	// 2c ,
  $08,$08,$08,$08,$08,	// 2d -
  $00,$60,$60,$00,$00,	// 2e .
  $20,$10,$08,$04,$02,	// 2f /
  $3e,$51,$49,$45,$3e,	// 30 0
  $00,$42,$7f,$40,$00,	// 31 1
  $42,$61,$51,$49,$46,	// 32 2
  $21,$41,$45,$4b,$31,	// 33 3
  $18,$14,$12,$7f,$10,	// 34 4
  $27,$45,$45,$45,$39,	// 35 5
  $3c,$4a,$49,$49,$30,	// 36 6
  $01,$71,$09,$05,$03,	// 37 7
  $36,$49,$49,$49,$36,	// 38 8
  $06,$49,$49,$29,$1e,	// 39 9
  $00,$36,$36,$00,$00,	// 3a :
  $00,$56,$36,$00,$00,	// 3b ;
  $08,$14,$22,$41,$00,	// 3c <
  $14,$14,$14,$14,$14,	// 3d =
  $00,$41,$22,$14,$08,	// 3e >
  $02,$01,$51,$09,$06,	// 3f ?
  $32,$49,$79,$41,$3e,	// 40 @
  $7e,$11,$11,$11,$7e,	// 41 A
  $7f,$49,$49,$49,$36,	// 42 B
  $3e,$41,$41,$41,$22,	// 43 C
  $7f,$41,$41,$22,$1c,	// 44 D
  $7f,$49,$49,$49,$41,	// 45 E
  $7f,$09,$09,$09,$01,	// 46 F
  $3e,$41,$49,$49,$7a,	// 47 G
  $7f,$08,$08,$08,$7f,	// 48 H
  $00,$41,$7f,$41,$00,	// 49 I
  $20,$40,$41,$3f,$01,	// 4a J
  $7f,$08,$14,$22,$41,	// 4b K
  $7f,$40,$40,$40,$40,	// 4c L
  $7f,$02,$0c,$02,$7f,	// 4d M
  $7f,$04,$08,$10,$7f,	// 4e N
  $3e,$41,$41,$41,$3e,	// 4f O
  $7f,$09,$09,$09,$06,	// 50 P
  $3e,$41,$51,$21,$5e,	// 51 Q
  $7f,$09,$19,$29,$46,	// 52 R
  $46,$49,$49,$49,$31,	// 53 S
  $01,$01,$7f,$01,$01,	// 54 T
  $3f,$40,$40,$40,$3f,	// 55 U
  $1f,$20,$40,$20,$1f,	// 56 V
  $3f,$40,$38,$40,$3f,	// 57 W
  $63,$14,$08,$14,$63,	// 58 X
  $07,$08,$70,$08,$07,	// 59 Y
  $61,$51,$49,$45,$43,	// 5a Z
  $00,$7f,$41,$41,$00,	// 5b [
  $02,$04,$08,$10,$20,	// 5c Yen Currency Sign
  $00,$41,$41,$7f,$00,	// 5d ]
  $04,$02,$01,$02,$04,	// 5e ^
  $40,$40,$40,$40,$40,	// 5f _
  $00,$01,$02,$04,$00,	// 60 `
  $20,$54,$54,$54,$78,	// 61 a
  $7f,$48,$44,$44,$38,	// 62 b
  $38,$44,$44,$44,$20,	// 63 c
  $38,$44,$44,$48,$7f,	// 64 d
  $38,$54,$54,$54,$18,	// 65 e
  $08,$7e,$09,$01,$02,	// 66 f
  $0c,$52,$52,$52,$3e,	// 67 g
  $7f,$08,$04,$04,$78,	// 68 h
  $00,$44,$7d,$40,$00,	// 69 i
  $20,$40,$44,$3d,$00,	// 6a j
  $7f,$10,$28,$44,$00,	// 6b k
  $00,$41,$7f,$40,$00,	// 6c l
  $7c,$04,$18,$04,$78,	// 6d m
  $7c,$08,$04,$04,$78,	// 6e n
  $38,$44,$44,$44,$38,	// 6f o
  $7c,$14,$14,$14,$08,	// 70 p
  $08,$14,$14,$18,$7c,	// 71 q
  $7c,$08,$04,$04,$08,	// 72 r
  $48,$54,$54,$54,$20,	// 73 s
  $04,$3f,$44,$40,$20,	// 74 t
  $3c,$40,$40,$20,$7c,	// 75 u
  $1c,$20,$40,$20,$1c,	// 76 v
  $3c,$40,$30,$40,$3c,	// 77 w
  $44,$28,$10,$28,$44,	// 78 x
  $0c,$50,$50,$50,$3c,	// 79 y
  $44,$64,$54,$4c,$44,	// 7a z
  $00,$08,$36,$41,$00,	// 7b <
  $00,$00,$7f,$00,$00,	// 7c |
  $00,$41,$36,$08,$00,	// 7d >
  $10,$08,$08,$10,$08,	// 7e Right Arrow 	->  ???
  $78,$46,$41,$46,$78);	// 7f Left Arrow	<-  ???



var
  Form1: TForm1;
  ExitSave: Pointer;
  LPT_pins: Byte;
  ende: Boolean;
  Daten: Byte;
  xpos, ypos: Byte;

implementation

{$R *.DFM}

procedure LPT_OUT(out_pins: Byte);
begin
 asm
  push dx
  mov dx,LPT_adr
  mov al,out_pins
  out dx,al
  pop dx
 end;
end;

procedure HWinit;
begin
 LPT_pins := (p_PWR or p_CE) and (not p_RES);  //pwr on, CE on, RESET low
 LPT_OUT(LPT_pins);
 sleep(150);
 LPT_pins := LPT_pins or p_RES;     //RESET on
 LPT_OUT(LPT_pins);
end;

procedure MyExit;
begin
 ExitProc := ExitSave;    { Zuerst alten Vektor wiederherstellen }
 LPT_OUT($00);
end;

procedure clkdata(bits: Byte);
var bitcnt: Byte;
begin
 for bitcnt := 0 to 7 do
 begin
  LPT_pins := LPT_pins and (not p_CLK);  // CLK low
  LPT_OUT(LPT_pins);
  if (bits and $80) > 0 then
   LPT_pins := LPT_pins or p_DIN  // DIN on
  else LPT_pins := LPT_pins and (not p_DIN);  // DIN low
  LPT_OUT(LPT_pins);
  bits := bits shl 1;
  LPT_pins := LPT_pins or p_CLK;  // CLK on
  LPT_OUT(LPT_pins);
 end;
end;

procedure wrcomm(command: Byte);
begin
 LPT_pins := LPT_pins and (not p_DC);  // DC low
 LPT_OUT(LPT_pins);
 LPT_pins := LPT_pins and (not p_CE);  // CE low
 LPT_OUT(LPT_pins);
 clkdata(command);
 LPT_pins := LPT_pins or p_CE;  // CE on
 LPT_OUT(LPT_pins);
end;

procedure wrdata(data: Byte);
begin
 LPT_pins := LPT_pins or p_DC;  // DC on 
 LPT_OUT(LPT_pins);
 LPT_pins := LPT_pins and (not p_CE);  // CE low
 LPT_OUT(LPT_pins);
 clkdata(Data);
 LPT_pins := LPT_pins or p_CE;  // CE on
 LPT_OUT(LPT_pins);
end;

procedure setcusor(x,y: Byte);   
begin                              
 wrcomm($80 or (x and $7F));
 wrcomm($40 or (y and $07));        
end;

procedure clearram;  
var ramx, ramy: integer;
begin
 ramx := 0;
 ramy := 0;
 setcusor(ramx, ramy);
 while ramy < yres do
 begin
  setcusor(ramx, ramy);
  while ramx < xres do
  begin
   wrdata($0);
   inc(ramx);
  end;
  ramx := 0;
  inc(ramy);
 end;
end;

procedure wrchar(chr: char);
var i: integer;
begin
 if (integer(chr) < 32) or (integer(chr) > 127) then exit;
 i := 0;
 while i < 5 do
 begin
  wrdata(Zeichen[((5 * integer(chr)) - 160) + i]);
  inc(i);
 end;
 wrdata($0);
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
 ExitSave := ExitProc;
 ExitProc := @MyExit;
 LPT_pins := $00;
 LPT_OUT($00);
 xpos := $00;
 ypos := $00;
 HWinit;
 wrcomm($21);
 wrcomm($0C2);
 wrcomm($13);
 wrcomm($20);
 wrcomm($09);
 clearram;
 wrcomm($08);
 wrcomm($0C);
 setcusor($0, $0);
end;

procedure TForm1.ButtonEndeClick(Sender: TObject);  // ende
begin
 ende := true;
 Application.Terminate;     
end;

procedure TForm1.ButtonClearDisplayClick(Sender: TObject);
begin
 clearram;
 setcusor($0, $0);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
 if xpos >= 14 then
 begin
  inc(ypos);
  if ypos >= 6 then
  begin
   clearram;
   xpos := 0;
   ypos := 0;
  end;
  xpos := 0;
  setcusor(xpos, ypos);
 end;
 inc(xpos);
 wrchar(Key);
 Edit1.Clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 inc(ypos);
 xpos := 0;
 if ypos = 6 then
 begin
  xpos := 0;
  ypos := 0;
  clearram;
  setcusor(xpos, ypos);
 end
 else
 begin
  xpos := 0;
  setcusor(xpos, ypos);
 end;
 Edit1.SetFocus;
end;

procedure TForm1.ButtonBildClick(Sender: TObject);
var bol : boolean;
    BildName: string;
begin
 bol := OpenDialog1.Execute;
 BildName := OpenDialog1.FileName;
 Image1.Picture.LoadFromFile(BildName);
end;

procedure TForm1.ButtonBWClick(Sender: TObject);
var rbyte, gbyte, bbyte, hbyte: Cardinal;
    ix, iy, ox, oy: integer;
begin
 ox := Image1.Left;
 oy := Image1.Top;
 iy := 0;
 while iy < 48 do
 begin
  ix := 0;
  while ix < 84 do
  begin
   rbyte := Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy)] and $000000FF;
   gbyte := (Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy)] and $0000FF00) shr 8;
   bbyte := (Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy)] and $00FF0000) shr 16;
   hbyte := (rbyte + gbyte + bbyte) div 3;

   rbyte := Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy)] and $000000FF;
   gbyte := (Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy)] and $0000FF00) shr 8;
   bbyte := (Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy)] and $00FF0000) shr 16;
   hbyte := hbyte + ((rbyte + gbyte + bbyte) div 3);

   rbyte := Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy + 1)] and $000000FF;
   gbyte := (Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy + 1)] and $0000FF00) shr 8;
   bbyte := (Form1.Canvas.Pixels[(2 * ix + ox), (2 * iy + oy + 1)] and $00FF0000) shr 16;
   hbyte := hbyte + ((rbyte + gbyte + bbyte) div 3);

   rbyte := Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy + 1)] and $000000FF;
   gbyte := (Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy + 1)] and $0000FF00) shr 8;
   bbyte := (Form1.Canvas.Pixels[(2 * ix + ox + 1), (2 * iy + oy + 1)] and $00FF0000) shr 16;
   hbyte := hbyte + ((rbyte + gbyte + bbyte) div 3);

   hbyte := hbyte shr 2;

   if hbyte > (127 + (ScrollBar1.Position - 50)) then
    Image2.Canvas.Pixels[ix, iy] := $00FFFFFF
   else
    Image2.Canvas.Pixels[ix, iy] := $00000000;
   inc(ix);
  end;
  inc(iy);
 end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
 Label1.Caption := inttostr(100 - ScrollBar1.Position);
end;

procedure TForm1.ButtonToLcdClick(Sender: TObject);
var x, y, n : integer;
    muster, lcdbyte : Byte;
begin
 clearram;
 setcusor($0, $0);
 y := 0; n := 0;
 setcusor(0, 0);
 while y < 6 do
 begin
  x := 0;
  while x < 84 do
  begin
   muster := $01; lcdbyte := $00;
   while muster <> 0 do
   begin
    if Image2.Canvas.Pixels[x, (8 * y + n)] = 0 then lcdbyte := lcdbyte or muster;
    muster := muster shl 1;
    inc(n);
   end;
   n := 0;
   wrdata(lcdbyte);
   inc(x);
  end;
  inc(y);
  if y < 6 then setcusor(0, y);
 end; 
 setcusor(0, 0);
end;



end.
